# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead
%define _jarsign_opts --copy=%{_javadir} --unsign=%{_javadir}

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define section free

%global base_name jxpath
%global short_name commons-%{base_name}

%define reltag _redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

%define maven_version 1.3-redhat-1

Name:           apache-commons-jxpath
Version:        1.3
Release:        6%{?reltag}%{?dist}.1
Epoch:          0
Summary:        Simple XPath interpreter
Group:          Development/Libraries/Java

%if %with mead
Source100: commons-jxpath-commons-jxpath-1.3-redhat-1-sources.zip
Source101: commons-jxpath-commons-jxpath-1.3-redhat-1-patches.zip
Source102: commons-jxpath-1.3-redhat-1.pom
Source103: commons-jxpath-1.3-redhat-1-sources.jar
Source104: commons-jxpath-1.3-redhat-1-site.xml
Source105: commons-jxpath-1.3-redhat-1.jar
Source106: commons-jxpath-1.3-redhat-1-javadoc.jar
%endif

License:        ASL 2.0
URL:            http://commons.apache.org/jxpath/
%if %without mead
Source0:        http://www.apache.org/dist/commons/jxpath/source/commons-jxpath-1.3-src.tar.gz
Patch0:         apache-commons-jxpath-pom.patch
BuildRequires:  jpackage-utils
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  ant-junit 
BuildRequires:  junit
BuildRequires:  jboss-parent
BuildRequires:  commons-parent >= 0:12
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  commons-beanutils
BuildRequires:  slf4j
BuildRequires:  commons-collections >= 0:2.1.1
BuildRequires:  jdom >= 0:1.0
###BuildRequires:  mockrunner
BuildRequires:  jboss-jsp-api_2.2_spec
BuildRequires:  jboss-servlet-api_3.0_spec
%endif
Provides:       jakarta-%{short_name} = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name} < %{epoch}:%{version}-%{release}
Provides:       %{short_name} = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.6.0
Requires:       jpackage-utils
Requires:       slf4j

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Defines a simple interpreter of an expression language called XPath. 
JXPath applies  XPath  expressions to graphs of objects of all kinds: 
JavaBeans, Maps, Servlet contexts, DOM etc, including mixtures thereof.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Provides:       jakarta-%{short_name}-javadoc = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name}-javadoc < %{epoch}:%{version}-%{release}
Provides:       %{short_name}-javadoc = %{epoch}:%{version}-%{release}

%description javadoc
Javadoc for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

Provides:       jakarta-%{short_name}-repolib = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name}-repolib < %{epoch}:%{version}-%{release}
Provides:       %{short_name}-repolib = %{epoch}:%{version}-%{release}
%if 0
Obsoletes:      %{short_name}-repolib < %{epoch}:%{version}-%{release}
%endif

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n %{short_name}-%{version}-src
%patch0 -p1 -b .sav0
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file://`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.skip deploy javadoc:aggregate
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p}  %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p target/%{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}-%{namedversion}.jar
%else
%{__cp} -p %{_sourcedir}/%{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}-%{namedversion}.jar
%endif

%{__ln_s} %{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}.jar
%{__ln_s} %{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/jakarta-%{short_name}-%{namedversion}.jar
%{__ln_s} jakarta-%{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/jakarta-%{short_name}.jar

install -dm 755 %{buildroot}%{_javadocdir}/%{short_name}-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{short_name}-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/%{short_name}-%{namedversion}-javadoc.jar -d $RPM_BUILD_ROOT%{_javadocdir}/%{short_name}-%{namedversion}/
%{__rm} -r $RPM_BUILD_ROOT%{_javadocdir}/%{short_name}-%{namedversion}/META-INF
%endif

%{__ln_s} %{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/%{short_name}
%{__ln_s} %{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/jakarta-%{short_name}
%{__ln_s} jakarta-%{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/jakarta-%{short_name}-%{namedversion}

# pom
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}.pom
%else
%{__cp} -p %{_sourcedir}/%{short_name}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-%{short_name}.pom
%endif
%add_to_maven_depmap commons-jxpath commons-jxpath %{namedversion} JPP %{short_name} 
[ -f %{buildroot}%{_mavendepmapfragdir}/%{short_name} ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/%{short_name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%if %without mead
%doc LICENSE.txt NOTICE.txt
%endif

%{_javadir}*/%{short_name}-%{namedversion}.jar
%{_javadir}*/%{short_name}.jar
%{_javadir}*/jakarta-%{short_name}-%{namedversion}.jar
%{_javadir}*/jakarta-%{short_name}.jar
%{_mavendepmapfragdir}/%{short_name}
%{_mavenpomdir}/JPP-%{short_name}.pom

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{short_name}-%{namedversion}
%{_javadocdir}/%{short_name}
%{_javadocdir}/jakarta-%{short_name}-%{namedversion}
%{_javadocdir}/jakarta-%{short_name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.3-6_redhat_1.1
- Rebuild using cache signing

* Thu Jul 12 2012 Yong Yang <yyang@redhat.com> - 0:1.3-6
- First Mead build

* Sat Oct 09 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.3-5
- Provide compat symlinks for jakarta-commons-jxpath

* Thu Sep 23 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.3-4
- Drop Requires for apache-commons-parent

* Sun Sep 12 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.3-3
- Fix pom name

* Sun Sep 12 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.3-2
- OK move it to free

* Sun Nov 22 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.3-1
- 1.3
- rename to apache-commons-jxpath
- build with maven2 by default

* Wed Mar 18 2009 Yong Yang <yyang@redhat.com> - 0:1.2-5
- rebuild with new maven2 2.0.8 built in bootstrap mode

* Thu Feb 05 2009 Yong Yang <yyang@redhat.com> - 0:1.2-4
- Fix release tag

* Thu Jan 08 2009 Yong Yang <yyang@redhat.com> - 0:1.2-3jpp.1
- Import from dbhole's maven 2.0.8 packages, initial building

* Wed Apr 09 2008 Deepak Bhole <dbhole@redhat.com> - 0:1.2-2jpp.1
- Import from JPackage
- Added pom file

* Wed Jun 07 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2-2jpp
- First JPP 1.7 build

* Sat Sep 18 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.2-1jpp
- Upgrade to 1.2
- Use jdom-1.0-0.rc1.1jpp
- Relax some versioned dependencies

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.1-3jpp
- Rebuild with ant-1.6.2

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:1.1-2jpp
- Upgrade to Ant 1.6.X

* Mon Jan 19 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.1-1jpp
- First JPackage release
